/*
 * keytimer.c		Timer and interrupt process
 *			Copyright(C)2003 Kashi Electronics Designs,
 *			All Rights Reserved.
 *	Ver 1.0	Sep.8/2003 first release
 *
 *   This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *   This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 */
#include <pic18.h>
#include "config.h"

unsigned char	g_logtimer, g_commto;
unsigned char	g_key, g_keymask, g_keyRtimer;
unsigned char	g_loginterval, g_interval;
unsigned char	g_timer1, g_comled;

void interrupt ISR(void)
{
	unsigned char		key;

	if((TMR0IE)&&(TMR0IF)){
		TMR0IF = 0;						// clear TMR0 interrupt flag

		LATC0 = 0; TRISA |= 0x3c;
		key = (~((PORTA) >> 2)) & 0x0f;	// sampling SW0-3

		if( g_keymask ){
			g_keymask--;
			g_key = 0;

		} else {
			g_key = key;

		}			

		if(!key){
			g_keymask = 0;
			g_keyRtimer = 0;

		} else {
			if( g_keyRtimer < 250 )	// 10sec maximum
				g_keyRtimer++;
		}

		if( g_commto )
			g_commto--;

		if( g_timer1 )
			g_timer1--;

		if( g_comled )
			g_comled--;
		else
			LATA0 = 0;				// off green LED

		TMR0H = 0xf3;
		TMR0L = 0xcb;					// TMR0 = -3125, 25ms
		if(g_logtimer == 0){
			g_logtimer = g_interval;	// 200ms
			g_loginterval = 1;		// log data captured flag

		} else
			g_logtimer--;
	}
}

void		init_timer()
{
	INTCON2 = 0xff;
	T0CON = 0x05;						// PS = Xosc/4 * 1/64, 125KHz
	TMR0H = 0xf3;
	TMR0L = 0xcb;						// TMR0 = -3125, 25ms

	g_interval = LOGTCNT;
	g_logtimer = g_interval;			// @200ms
	g_loginterval = 0; g_keymask = 0;
	g_commto = 0;
	TMR0IE = 1;
}
